//-Player ThinkFrame-
CBW_Battle.PlayerThinkFrame = function(player)
	local pmo = player.mo
	//Validity check
	if not(pmo and pmo.valid) or player.playerstate != PST_LIVE then return end
	//Game Mode Check
	if maptol&(TOL_NIGHTS|TOL_XMAS) then return end
	//Update timers/stats
	player.charmedtime = max(0,$-1)
	player.actioncooldown = max(0,$-1)
	player.currentweapon = 0
	CBW_Battle.DoCharmed(player)
	CBW_Battle.DoBackdraft(player)
	
	//PvP Collision
	if G_RingSlingerGametype() then
		CBW_Battle.DoPlayerInteract(pmo,pmo.pushed)
		CBW_Battle.UpdateRecoilState(pmo)
		CBW_Battle.UpdateCollisionHistory(pmo)
	else
		pmo.flags = $&~MF_SPECIAL
	end

	//Perform Actions
	player.actionallowed = CBW_Battle.CanDoAction(player)
	local doaction = 0
	if player.cmd.buttons&BT_ATTACK then
		if player.buttonhistory&BT_ATTACK
			doaction = 2
		else
			doaction = 1
		end
	end	
	CBW_Battle.MasterActionScript(player,doaction)
end