CBW_Battle.Action.BombThrow=function(mo,doaction)
	if not(CBW_Battle.CanDoAction(mo.player)) then return end
	//Action info
	mo.player.actiontext = "Throw Bomb"
	mo.player.actionrings = 10
	local subtract = 0
	if not(mo.player.cooldown)
		then 
		mo.player.disableringslinger = false
		if mo.player.weapondelay then subtract = 1 end
	end
	doaction = CBW_Battle.CheckRings(mo.player,$,mo.player.actionrings-1)
	
	//Throw bomb
	if doaction == 1 then
		local bomb = P_SPMAngle(mo,MT_FBOMB,mo.angle,mo.player.autoaim^^1)
		if bomb and bomb.valid then
			if G_RingSlingerGametype() then
				//Do skincolor
				bomb.state = S_COLORBOMB1
				bomb.color = mo.player.skincolor
			end
			
			//Do Physics
			local water = CBW_Battle.WaterFactor(mo)
			if mo.player.pflags&PF_BOUNCING then
				P_InstaThrust(bomb,mo.angle,FRACUNIT/100)
				bomb.momz = bomb.scale*8*P_MobjFlip(mo)/water
			elseif mo.player.autoaim and CBW_Battle.AutoAim(mo,mo.angle,60,-1,true,bomb,bomb.scale*20/water,MF_MONITOR|MF_BOSS|MF_ENEMY)
				then
				bomb.momz = $+bomb.scale*4*P_MobjFlip(mo)/water
			elseif mo.player.autoaim
				bomb.momz = $+bomb.scale*8*P_MobjFlip(mo)/water
			else
				bomb.momz = $+bomb.scale*4*P_MobjFlip(mo)/water
			end
			bomb.flags = $|MF_BOUNCE|MF_GRENADEBOUNCE
			bomb.fuse = 10*TICRATE
			CBW_Battle.PayRings(mo.player,mo.player.actionrings-subtract)
			mo.player.actioncooldown = TICRATE
			mo.player.weapondelay = TICRATE
		end
	end
end

CBW_Battle.FBombThink=function(mo)
	if mo.flags&(MF_MISSILE|MF_GRENADEBOUNCE) and P_IsObjectOnGround(mo) then
		P_SetObjectMomZ(mo,FRACUNIT*4)
	end
end

CBW_Battle.FBombDetonate=function(mo)
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0
	S_StartSound(mo,sfx_s3k4e)
	P_KillMobj(mo)
	return true
end

CBW_Battle.PlayerBombDamage = function(pmo,mo,source)
	if mo and mo.valid and mo.type == MT_FBOMB and mo.fuse and pmo and pmo.valid and pmo.player and source and source.valid and source.player
		and CBW_Battle.PlayerCanBeDamaged(pmo.player) and not(CBW_Battle.MyTeam(pmo.player,source.player))
		then mo.fuse = 1
	end
end