local L = CBW_Battle
L.ActionChar["sonic"] = L.Action.SuperSpinJump
L.ActionChar["tails"] = L.Action.Sentry
L.ActionChar["knuckles"] = L.Action.Dig
L.ActionChar["amy"] = L.Action.CharmBeam
L.ActionChar["fang"] = L.Action.BombThrow
L.ActionChar["metalsonic"] = L.Action.ChargeBlast
L.ActionChar["tageggrobo"] = L.Action.TagEggRobo

L.MasterActionScript = function(player,doaction)
	local pressedaction = doaction
	local mo = player.mo
	if not(mo and mo.valid and mo.player and mo.player.valid) then return end
	
	if doaction > 0 and (
		player.actioncooldown
		or player.exiting
		or player.charmed
		or player.pflags&PF_STASIS
		or not(player.actionallowed)
		) then
		doaction = -1
	end

	//Get actiontype
	if player.pflags&PF_TAGIT then player.actiontype = "tageggrobo"
	elseif mo.player.actiontype != mo.skin then
		player.actiontype = mo.skin
		L.ResetPlayerProperties(mo.player,false,false)
	end
	
	local t = player.actiontype
	if player.disableringslinger then player.weapondelay = 2 end
	if L.ActionChar[t] != nil then
		L.ActionChar[t](mo,doaction,pressedaction)
		//For custom characters
		if mo.player.spendrings == 1 then
			mo.player.spendrings = 0
			L.PayRings(mo.player)
		elseif (doaction == -1 or mo.player.spendrings == -1) and pressedaction == 1 then
			mo.player.spendrings = 0
			S_StartSound(mo,sfx_s3k8c,player)
		end
	else
		mo.player.actiontext = nil
		mo.player.actiontext2 = nil
		mo.player.actionrings = 0
	end
	//Action successful
	return true
end