CBW_Battle.TagVictorCheck = function()
	local playercount = 0
	local downcount = 0
	
	for player in players.iterate
		local pmo = player.mo
		
		player.buttonhistory = player.cmd.buttons
		
		//Get player counts
		if player.mo and player.mo.valid
			playercount = $+1
			if player.pflags&PF_TAGIT then
				downcount = $+1
			end
		end

		//Update HUD text
		if (player.actiontext2 or player.actiontextflags2)
			if not(player.actiontexttime) then
				player.actiontext2 = nil
				player.actiontextflags2 = nil
				player.actiontexttime = 0
			else
				player.actiontexttime = $-1
			end
		else
			player.actiontexttime = $+1
		end
		
		//Validity check
		if not(player.mo and player.mo.valid and player.playerstate == PST_LIVE)
			player.actionstate = 0
			player.buttonhistory = player.cmd.buttons
		end
	end
	
	//Gamemode win condition check
	if downcount == playercount and playercount > 1 then 
		G_ExitLevel()
		return true
	end
	return false
end

CBW_Battle.TagNakedHit = function(mo,missile,owner,knockback)
	if G_TagGametype() == false then return false end
	mo.player.pflags = $|PF_TAGIT
	local naked = not(mo.player.rings or mo.player.powers[pw_shield])
	if not(naked) then return false end
	if knockback != false then
		P_DoPlayerPain(mo.player,missile,owner)
		P_PlayDeathSound(mo,mo.player)
	end
	P_AddPlayerScore(owner.player,100)
	return true
end
